/*
 * Op- en aftellende teller
 * Versie 0.1, FPCUser
 * 8 september 2014
 */

#include "Arduino.h"
#include "counters.h"

// constructors
 
 /**
  * default constructor
  */
 CTUD::CTUD() {
 	_pv = 0;
 	_cv = 0;
 	_qu = false;
 	_qd = false;
 	_fu = false;
 	_fd = false;
 }

/**
 * overloaded constructor met als argument de bovenwaarde
 */
CTUD::CTUD(uint16_t AValue) {
	_pv = AValue;
}

// mutators

/**
 * Zet de interne telwaarde op  0 (nul)
 */	
 void CTUD::Reset() {
 	_cv = 0;
 }

/**
 * Geef een limiet (bovenwaarde) op
 */
 void CTUD::setPV(uint16_t AValue) {
 	if(AValue != _pv) {
 		_pv = AValue;
 	}
 }

/**
 * Tel oppulsen
 */
 void CTUD::countUp(bool _cu) {
	if(_cv < 65535) {			// einde optelling nog niet bereikt
		if(!_fu && _cu) {		// vorige status telingang was laag, telingang is nu hoog
			_cv++;				// dus optellen
			_fu = true;			// en blokkeren voor het hoog blijven van telingang
		}
		if(_fu && !_cu) {		// vorige status telingang was hoog, telingang is nu laag
			_fu = false;		// dus blokkering weer opheffen
		}
	}
 }

/**
 * Tel neerpulsen
 */
 void CTUD::countDown(bool _cd) {
 	if(_cv > 0) {				// einde aftelling nog niet bereikt
		if(!_fd && _cd) {		// vorige status telingang was laag, telingang is nu hoog
			_cv--;				// dus aftellen
			_fd = true;			// en blokkeren voor het hoog blijven van telingang
		}
		if(_fd && !_cd) {		// vorige status telingang was hoog, telingang is nu laag
			_fd = false;		// dus blokkering weer opheffen
		}
	}
 }


// accessors

/**
 *   Geef interne telwaarde
 */
 uint16_t CTUD::getCV() {
	return _cv;
 }

/**
 * Geef waar (true) als bovenwaarde is bereikt
 */
 bool CTUD::getQU() {
 	if(_cv < _pv) {
		_qu = false;	
	}
	else {
		_qu = true;
	}
 	return _qu;
 }

/**
 * Geef waar (true) als onderwaarde (0) is bereikt
 */
 bool CTUD::getQD() {
 	if(_cv > 0) {
		_qd = false;
	}
	else {
		_qd = true;	
	}	 	
	return _qd;
}