/*
 * Bestand: sketch_counter_1a.ino
 * Datum: 8 september 2014
 * Doel: test van een objekt van de klasse CTUD (op- en aftellende teller)
         versie met variabelen
 */

#include "counters.h"

boolean CU;					// ingang oppuls
boolean CD;					// ingang neerpuls
boolean QU;					// uitgang, true als bovenwaarde is bereikt
boolean QD;					// uitgang, true als onderwaarde (0) is bereikt
uint16_t PV;				// limiet, bovenste waarde
CTUD teller;				// maak het objekt teller v/d klasse CTUD

unsigned int temp = 0;		// 'oude' waarde van CV, even nodig bij test met serial monitor

void setup() {
	Serial.begin(9600);		// nodig voor de test
	pinMode(12, OUTPUT);
	pinMode(13, OUTPUT);
	PV = 5;					// zo maar een bovenwaarde
	teller.setPV(PV);
}

void loop() {	
	// telingang oppulsen
	CU = digitalRead(2);
	teller.countUp(CU);

	// telingang neerpulsen
	CD = digitalRead(3);
	teller.countDown(CD);

	// resetingang
	if(digitalRead(4)) {
		teller.Reset();
	}
	
	// uitgang onderwaarde bereikt
	QD = teller.getQD();
	if(QD){
		digitalWrite(12, HIGH);
		} else {
			digitalWrite(12, LOW);
		}

	// uitgang bovenwaarde bereikt
	QU = teller.getQU();
	if(QU){
		digitalWrite(13, HIGH);
		} else {
			digitalWrite(13, LOW);
		}


	// voor de test: toon de hudige telwaarde
	if(temp != teller.getCV()) {
		Serial.println(teller.getCV());
		temp = teller.getCV();
	}
	delay(500);

}